import { jsx as T, jsxs as pe } from "react/jsx-runtime";
import ye, { useRef as f, useEffect as O, useCallback as me, useMemo as J, useState as v, useId as xe, useReducer as he, useLayoutEffect as I } from "react";
import c from "clsx";
/*!
  @versini/ui-textarea v3.0.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTAREA__ || (window.__VERSINI_UI_TEXTAREA__ = {
    version: "3.0.0",
    buildTime: "01/03/2025 10:45 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const K = "av-text-area", Ae = "av-text-area-wrapper", D = "av-text-area-helper-text", Te = "av-text-area__control--right", ge = "av-text-area__control--left";
function _e() {
  const e = f(!1);
  return O(() => (e.current = !0, () => {
    e.current = !1;
  }), []), me(() => e.current, []);
}
function be(e) {
  return J(() => e.every((r) => r == null) ? () => {
  } : (r) => {
    e.forEach((t) => {
      typeof t == "function" ? t(r) : t != null && (t.current = r);
    });
  }, e);
}
const ke = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function W(e) {
  const r = _e(), t = f(0), n = f(null), [a, o] = v(ke), s = J(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((l) => {
    const i = l[0];
    i && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      n.current && r() && o(i.contentRect);
    }));
  }), [r]);
  return O(() => (n.current && (s == null || s.observe(n.current, e)), () => {
    s == null || s.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [s, e]), [n, a];
}
function Re({
  value: e,
  defaultValue: r,
  finalValue: t,
  onChange: n = () => {
  },
  initialControlledDelay: a = 0
}) {
  const [o, s] = v(!1), [l, i] = v(
    r !== void 0 ? r : t
  ), p = (y) => {
    i(y), n == null || n(y);
  };
  return O(() => {
    (async () => e !== void 0 && !o && a > 0 && (await new Promise(
      (y) => setTimeout(y, a)
    ), s(!0)))();
  }, [e, a, o]), e !== void 0 ? !o && a > 0 ? ["", n, !0] : [e, n, !0] : [l, p, !1];
}
function ve(e) {
  const r = xe();
  if (!e)
    return r;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${r}`;
  if (typeof e == "object") {
    const { id: t, prefix: n = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${n}${t}` : `${n}${r}`;
  }
}
const Q = "SET_ANNOUNCEMENT", Y = "CLEAR_ANNOUNCEMENT", Ee = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, Ne = (e, r) => {
  switch (r == null ? void 0 : r.type) {
    case Q:
      return {
        ...e,
        announcement: r.payload
      };
    case Y:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, Ce = ({
  onAnnouncementClear: e,
  dispatch: r
}) => {
  r({
    type: Y
  }), typeof e == "function" && e();
}, q = ({
  children: e,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: n,
  dispatch: a
}) => {
  clearTimeout(t.current), e !== null && a({
    type: Q,
    payload: e
  }), r && (t.current = setTimeout(
    () => Ce({
      onAnnouncementClear: n,
      dispatch: a
    }),
    r
  ));
}, Ie = ({
  children: e,
  announcementTimeoutRef: r,
  announcementDelay: t,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: a,
  onAnnouncementClear: o,
  dispatch: s
}) => {
  clearTimeout(r.current), t ? r.current = setTimeout(q, t, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: o,
    dispatch: s
  }) : q({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: o,
    dispatch: s
  });
};
function Le({
  children: e,
  className: r,
  politeness: t,
  role: n = null,
  announcementDelay: a,
  clearAnnouncementDelay: o,
  onAnnouncementClear: s,
  visible: l,
  ...i
}) {
  const p = f(null), y = f(null), [b, E] = he(Ne, {
    announcement: null
  });
  let g = t;
  typeof g > "u" && (g = n ? Ee[n] : "assertive"), O(() => {
    Ie({
      announcementTimeoutRef: p,
      announcementDelay: a,
      children: e,
      clearAnnouncementDelay: o,
      clearAnnouncementTimeoutRef: y,
      onAnnouncementClear: s,
      dispatch: E
    });
  }, [
    e,
    a,
    o,
    s
  ]);
  const d = c(r, {
    "sr-only": !l
  });
  return /* @__PURE__ */ T(
    "div",
    {
      "aria-live": g,
      ...n && { role: n },
      className: d,
      ...i,
      children: b.announcement
    }
  );
}
/*!
  @versini/ui-liveregion v1.3.0
  © 2025 gizmette.com
*/
try {
  window.__VERSINI_UI_LIVEREGION__ || (window.__VERSINI_UI_LIVEREGION__ = {
    version: "1.3.0",
    buildTime: "01/03/2025 10:45 AM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Se = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", Oe = ({ mode: e }) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), we = ({
  focusMode: e
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), $e = ({
  noBorder: e,
  error: r
}) => c("border-2", {
  "border-border-dark": !e && !r,
  "focus:border-border-dark": !e && r,
  "border-border-error-dark": !e && r,
  "border-transparent": e
}), He = ({
  disabled: e,
  raw: r,
  error: t,
  mode: n,
  leftElement: a,
  rightElement: o
}) => {
  if (r)
    return "";
  if (e)
    return c(
      "transform translate-y-0 scale-100 absolute px-2 cursor-not-allowed opacity-50 font-medium",
      {
        "translate-x-[12px]": o === !0 && !a || !o && !a
      }
    );
  if (!t)
    return c(
      "absolute px-2 cursor-text font-medium transform translate-y-0 scale-100",
      {
        "translate-x-[12px]": o === !0 && !a || !o && !a,
        "text-copy-medium": n === "dark",
        "text-copy-dark": n === "light",
        "text-copy-dark dark:text-copy-medium": n === "system",
        "text-copy-medium dark:text-copy-dark": n === "alt-system"
      }
    );
  if (t)
    return c(
      "absolute px-2 cursor-text font-medium transform translate-y-0 scale-100",
      {
        "translate-x-[12px]": o === !0 && !a || !o && !a,
        "text-copy-medium": n === "dark",
        "text-copy-error-dark": n === "light",
        "text-copy-error-dark dark:text-copy-error-light": n === "system",
        "text-copy-medium dark:text-copy-error-dark": n === "alt-system"
      }
    );
}, Me = ({
  error: e,
  raw: r,
  mode: t,
  disabled: n
}) => {
  if (r)
    return "";
  if (n)
    return c(
      D,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return c(D, "absolute px-2 font-medium", {
      "text-copy-medium": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-medium": t === "system",
      "text-copy-medium dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return c(D, "absolute px-2 font-medium", {
      "text-copy-error-light": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light": t === "system",
      "dark:text-copy-error-dark text-copy-error-light": t === "alt-system"
    });
}, De = ({
  className: e,
  textAreaClassName: r,
  raw: t,
  focusMode: n,
  disabled: a,
  noBorder: o,
  error: s,
  mode: l,
  leftElement: i,
  rightElement: p
}) => {
  const y = t ? e : c(
    "relative flex w-full flex-col justify-center",
    Ae,
    e
  ), b = t ? c(r) : c(
    K,
    r,
    Se(),
    Oe({ mode: l }),
    we({ focusMode: n }),
    $e({
      noBorder: o,
      error: s
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": a
    }
  ), E = t ? void 0 : "sr-only", g = He({
    disabled: a,
    raw: t,
    error: s,
    mode: l,
    rightElement: p,
    leftElement: i
  }), d = Me({
    error: s,
    raw: t,
    mode: l,
    disabled: a
  }), N = t ? void 0 : c(Te, "absolute"), h = t ? void 0 : c(ge, "absolute");
  return {
    wrapper: y,
    textArea: b,
    accessibleLabel: E,
    visibleLabel: g,
    helperText: d,
    rightElement: N,
    leftElement: h
  };
}, Fe = ({
  scrollHeight: e,
  currentHeight: r,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: n = 0
}) => {
  let s, l;
  if (e > 0 && e !== r) {
    const i = e - r, p = Math.abs(i / 24);
    s = t + -1 * Math.sign(i) * (12 * p), l = n + Math.sign(i) * (12 * p);
  }
  return {
    labelOffset: s,
    helperTextOffset: l,
    scrollHeight: e
  };
}, Pe = ye.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: n = !1,
    raw: a = !1,
    className: o,
    textAreaClassName: s,
    mode: l = "system",
    focusMode: i = "system",
    value: p,
    defaultValue: y,
    disabled: b = !1,
    noBorder: E = !1,
    labelId: g,
    helperText: d = "",
    helperTextOnFocus: N = !1,
    rightElement: h,
    leftElement: k,
    onChange: F,
    onFocus: P,
    onBlur: U,
    ...Z
  }, ee) => {
    var B;
    const x = f(null), te = be([ee, x]), [re, L] = W(), [ne, R] = W(), w = f(80), V = f(-25), m = f(null), X = f(30), S = f(null), C = ve({ id: e, prefix: `${K}-` }), [j, ae] = v(0), [G, oe] = v(0), [se, z] = v(
      !!(!N && d)
    ), ce = `${r} error, ${d}`, _ = De({
      className: o,
      textAreaClassName: s,
      error: n,
      raw: a,
      focusMode: i,
      disabled: b,
      noBorder: E,
      mode: l,
      rightElement: !!h,
      leftElement: !!k
    }), [A, le] = Re({
      value: p,
      initialControlledDelay: 20,
      defaultValue: y,
      onChange: (u) => {
        F && F({
          target: {
            value: u
          }
        });
      }
    }), ie = (u) => {
      le(u.target.value);
    }, ue = (u) => {
      N && d && z(!0), P && P(u);
    }, de = (u) => {
      N && d && !A && z(!1), U && U(u);
    };
    return I(() => {
      L && L.width && ae(L.width + 18 + 10);
    }, [L]), I(() => {
      R && R.width && oe(R.width + 18 + 10);
    }, [R]), I(() => {
      a || x && x.current && A !== void 0 && (x.current.style.height = "inherit", x.current.style.height = x.current.scrollHeight + "px");
    }, [A, a]), I(() => {
      a || setTimeout(() => {
        var u;
        (u = m == null ? void 0 : m.current) == null || u.style.setProperty(
          "--av-text-area-wrapper-transition",
          A ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [A, a]), I(() => {
      var u, $;
      if (!a && x && x.current && A !== void 0) {
        const { labelOffset: H, helperTextOffset: M, scrollHeight: fe } = Fe({
          scrollHeight: x.current.scrollHeight,
          currentHeight: w.current,
          currentLabelOffset: V.current,
          currentHelperTextOffset: X.current
        });
        H && (V.current = H, (u = m == null ? void 0 : m.current) == null || u.style.setProperty(
          "--av-text-area-label",
          `${H}px`
        )), M && (X.current = M, ($ = S == null ? void 0 : S.current) == null || $.style.setProperty(
          "--av-text-area-helper-text",
          `${M}px`
        )), w.current = fe || w.current;
      }
    }, [A, a]), R.width > 0 && ((B = m == null ? void 0 : m.current) == null || B.style.setProperty(
      "--tw-translate-x",
      `${12 + R.width + 5}px`
    )), /* @__PURE__ */ pe("div", { className: _.wrapper, children: [
      /* @__PURE__ */ T(
        "label",
        {
          htmlFor: C,
          id: g,
          className: _.accessibleLabel,
          children: t
        }
      ),
      k && /* @__PURE__ */ T(
        "div",
        {
          ref: ne,
          className: _.leftElement,
          children: k
        }
      ),
      /* @__PURE__ */ T(
        "textarea",
        {
          ref: te,
          id: C,
          name: r,
          disabled: b,
          placeholder: a ? void 0 : " ",
          className: _.textArea,
          rows: 1,
          ...d && { "aria-describedby": `${C}-helper` },
          ...n && { "aria-invalid": "true" },
          ...h && !k && !a && { style: { paddingRight: j } },
          ...k && !h && !a && { style: { paddingLeft: G } },
          ...h && k && !a && {
            style: {
              paddingRight: j,
              paddingLeft: G
            }
          },
          value: A,
          onChange: ie,
          onFocus: ue,
          onBlur: de,
          ...Z
        }
      ),
      !a && /* @__PURE__ */ T(
        "label",
        {
          ref: m,
          "aria-hidden": !0,
          htmlFor: C,
          className: `${_.visibleLabel}`,
          children: t
        }
      ),
      se && /* @__PURE__ */ T(
        "div",
        {
          ref: S,
          id: `${C}-helper`,
          className: _.helperText,
          children: d
        }
      ),
      h && /* @__PURE__ */ T(
        "div",
        {
          ref: re,
          className: _.rightElement,
          children: h
        }
      ),
      n && d && /* @__PURE__ */ T(Le, { politeness: "polite", clearAnnouncementDelay: 500, children: ce })
    ] });
  }
);
Pe.displayName = "TextArea";
export {
  K as TEXT_AREA_CLASSNAME,
  ge as TEXT_AREA_CONTROL_LEFT_CLASSNAME,
  Te as TEXT_AREA_CONTROL_RIGHT_CLASSNAME,
  D as TEXT_AREA_HELPER_TEXT_CLASSNAME,
  Ae as TEXT_AREA_WRAPPER_CLASSNAME,
  Pe as TextArea
};
